<?xml version="1.0" encoding="UTF-8"?>
<databaseChangeLog
        xmlns="http://www.liquibase.org/xml/ns/dbchangelog"
        xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
        xsi:schemaLocation="http://www.liquibase.org/xml/ns/dbchangelog http://www.liquibase.org/xml/ns/dbchangelog/dbchangelog-3.1.xsd">

    <changeSet id="1" author="Elchin Aliyev">

        <createTable tableName="users">
            <column name="id" autoIncrement="true" type="bigint">
                <constraints primaryKey="true"/>
            </column>
            <column name="username" type="varchar(255)">
                <constraints nullable="false" unique="true"/>
            </column>
            <column name="first_name" type="varchar(255)">
                <constraints nullable="false"/>
            </column>
            <column name="last_name" type="varchar(255)">
                <constraints nullable="false"/>
            </column>
            <column name="password" type="varchar(255)">
                <constraints nullable="false"/>
            </column>
            <column name="active" type="boolean">
                <constraints nullable="false"/>
            </column>
            <column name="created" type="TIMESTAMP" defaultValueComputed="current_timestamp">
                <constraints nullable="false"/>
            </column>
            <column name="updated" type="TIMESTAMP"/>
        </createTable>


        <createTable tableName="roles">
            <column name="id" autoIncrement="true" type="bigint">
                <constraints primaryKey="true"/>
            </column>
            <column name="role_name" type="varchar(255)">
                <constraints nullable="false" unique="true"/>
            </column>
            <column name="active" type="boolean">
                <constraints nullable="false"/>
            </column>
            <column name="created" type="TIMESTAMP" defaultValueComputed="current_timestamp">
                <constraints nullable="false"/>
            </column>
            <column name="updated" type="TIMESTAMP"/>
        </createTable>


        <createTable tableName="users_roles">
            <column name="id" autoIncrement="true" type="bigint">
                <constraints primaryKey="true"/>
            </column>
            <column name="user_id" type="bigint">
                <constraints nullable="false"
                             referencedTableName="users"
                             referencedColumnNames="id"
                             foreignKeyName="users_roles_user_id_fk"/>
            </column>
            <column name="role_id" type="bigint">
                <constraints nullable="false"
                             referencedTableName="roles"
                             referencedColumnNames="id"
                             foreignKeyName="users_roles_role_id_fk"/>
            </column>
            <column name="active" type="boolean">
                <constraints nullable="false"/>
            </column>
            <column name="created" type="TIMESTAMP" defaultValueComputed="current_timestamp">
                <constraints nullable="false"/>
            </column>
            <column name="updated" type="TIMESTAMP"/>
        </createTable>

    </changeSet>

</databaseChangeLog>